<script>
	import OptionsSelector from '../OptionsSelector.svelte';

	let numbers = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
	let selectedNumbers = []; // initialized as array for multiple
	let selectedNumber; // if not, it indicates single selection

	let fruits = [
		{ id: 1, name: 'Orange' },
		{ id: 2, name: 'Apple' },
		{ id: 3, name: 'Watermelon' },
		{ id: 4, name: 'Kiwi' },
		{ id: 5, name: 'Avocado' },
	];
	let selectedFruits = [];
	let selectedFruit; // check "identify" prop

	let selectedFruitsIds = [];
	let selectedFruitId;
</script>

<style>
	article {
		margin-bottom: 20px;
	}
	h2 {
		margin-bottom: 5px;
	}
	ul {
		padding: 0;
		margin: 0;
		margin-bottom: 10px;
		display: flex;
		gap: 5px;
	}
	code {
		display: block;
		padding: 10px;
		background-color: #eee;
	}
	button {
		margin: 0;
	}
	.selected {
		background-color: #ccc;
	}
</style>

<main>
	<article>
		<h2>Multiple numbers</h2>
		<ul>
			<OptionsSelector
				options={numbers}
				bind:value={selectedNumbers}
				let:option
				let:selected
				let:toggle
			>
				<button class:selected={selected} on:click={toggle}>
					{option}
				</button>
			</OptionsSelector>
		</ul>
		<code>
			{JSON.stringify(selectedNumbers)}
		</code>
	</article>

	<article>
		<h2>Single number</h2>
		<ul>
			<OptionsSelector
				options={numbers}
				bind:value={selectedNumber}
				let:option
				let:selected
				let:toggle
			>
				<button class:selected={selected} on:click={toggle}>
					{option}
				</button>
			</OptionsSelector>
		</ul>
		<code>
			{JSON.stringify(selectedNumber)}
		</code>
	</article>

	<article>
		<h2>Multiple objects</h2>
		<ul>
			<OptionsSelector
				options={fruits}
				identify={fruit => fruit.id}
				bind:value={selectedFruits}
				let:option
				let:selected
				let:toggle
			>
				<button class:selected={selected} on:click={toggle}>
					{option.name}
				</button>
			</OptionsSelector>
		</ul>
		<code>
			{JSON.stringify(selectedFruits)}
		</code>
	</article>

	<article>
		<h2>Single object</h2>
		<ul>
			<OptionsSelector
				options={fruits}
				identify={fruit => fruit?.id}
				bind:value={selectedFruit}
				let:option
				let:selected
				let:toggle
			>
				<button class:selected={selected} on:click={toggle}>
					{option.name}
				</button>
			</OptionsSelector>
		</ul>
		<code>
			{JSON.stringify(selectedFruit)}
		</code>
	</article>

	<article>
		<h2>Multiple objects (id)</h2>
		<ul>
			<OptionsSelector
				valueAsId
				options={fruits}
				identify={fruit => fruit?.id}
				bind:value={selectedFruitsIds}
				let:option
				let:selected
				let:toggle
			>
				<button class:selected={selected} on:click={toggle}>
					{option.name}
				</button>
			</OptionsSelector>
		</ul>
		<code>
			{JSON.stringify(selectedFruitsIds)}
		</code>
	</article>

	<article>
		<h2>Single object (id)</h2>
		<ul>
			<OptionsSelector
				valueAsId
				options={fruits}
				identify={fruit => fruit?.id}
				bind:value={selectedFruitId}
				let:option
				let:selected
				let:toggle
			>
				<button class:selected={selected} on:click={toggle}>
					{option.name}
				</button>
			</OptionsSelector>
		</ul>
		<code>
			{JSON.stringify(selectedFruitId)}
		</code>
	</article>
</main>
